package labs;

import java.util.Scanner;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.transaction.TransactionManager;

import org.infinispan.Cache;
import org.infinispan.manager.DefaultCacheManager;

public class Node {

	private static final String KEY = "key";
	private final ExecutorService es = Executors.newFixedThreadPool(2);
	private DefaultCacheManager cacheManager;
	
	public static void main(String[] args) throws Exception {
		final Node n = new Node();
		n.cacheManager = new DefaultCacheManager("infinispan-distribution.xml");
		final Cache<String, Integer> cache = n.cacheManager.getCache("Demo");
		
		Scanner keyIn = new Scanner(System.in);
		while (true) {
			System.out.print("\nEnter 's' to start, or 'k' to print KEY value:");
			String key = keyIn.next();
			if (key.startsWith("s")) {
				for (int i = 0; i < 10000; i++) {
					n.es.execute(new Runnable() {
						@Override
						public void run() {
							n.locksTest(cache);
						}
					});
				}
			} else if (key.startsWith("k")) {
				Integer v = cache.get(KEY);
				System.out.println("val: " + v);
			}
		}
	}
	
	   private void locksTest(Cache<String, Integer> cache) {
			TransactionManager manager = cache.getAdvancedCache().getTransactionManager();
			try {
				manager.begin();
				if (!cache.getAdvancedCache().lock(KEY)) {
					System.out.println("WARNING: can't get lock");
					manager.commit();
					return;
				}
				Integer value = cache.get(KEY);
				if (value == null) {
					value = 0;
				}
				value++;
				System.out.println("value: " + value);
				cache.put(KEY, value);
				manager.commit();
			} catch (Exception e) {
				try {
					manager.rollback();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
				e.printStackTrace();
			}
	   }
	   

}
